Index: LMDZ6/branches/Portage_acc/libf/phylmd/lscp_mod.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/lscp_mod.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/lscp_mod.F90	(revision 4446)
@@ -654,8 +585,8 @@
                 zq(i)=1.e-15
             ENDIF
+            ! c_iso: do something similar for isotopes
 
      ENDDO
     
-
     ! --------------------------------------------------------------------
     ! P2> Cloud formation
@@ -670,7 +601,6 @@
     ! -------------------------------------------------------------------
 
-           
         ! P2.1> With the PDFs (log-normal, bigaussian) 
-        ! cloud propertues calculation with the initial values of t and q
+        ! cloud properties calculation with the initial values of t and q
         ! ----------------------------------------------------------------
 
@@ -697,8 +627,7 @@
                          ratqs,zqs,t)
 
-
                 !Jean Jouhaud's version, Decembre 2018 
-                !-------------------------------------              
-             
+                !-------------------------------------
+
                 ELSEIF (iflag_cloudth_vert.EQ.6) THEN
 
@@ -714,5 +643,5 @@
                 ! + stationary mixed-phase cloud model
 
-                    CALL cloudth_mpc(klon,klev,k,mpc_bl_points,            &
+                    CALL cloudth_mpc(klon,klev,k,iflag_mpc_bl,mpc_bl_points, &
                          t,ztv,zq,zqta,fraca, zpspsk,                      &
                          paprs,pplay,ztla,zthl,ratqs,zqs,psfl,             &
@@ -740,5 +669,5 @@
 
         ELSE
-                ! When iflag_cld_th=5, we always assume  
+                ! When iflag_cld_th=5, we always assume
                 ! bi-gaussian distribution
             lognormale = .FALSE.
@@ -746,5 +675,4 @@
         ENDIF
 
-
         DT(:) = 0.
         n_i(:)=0
@@ -754,16 +682,18 @@
         ! Treatment of non-boundary layer clouds (lognormale)
         ! condensation with qsat(T) variation (adaptation)
-        ! Iterative Loop to converge towards qsat
-        
-        
+        ! Iterative resolution to converge towards qsat
+        ! with update of temperature, ice fraction and qsat at 
+        ! each iteration
+
+        ! todoan -> sensitivity to iflag_fisrtilp_qsat
         DO iter=1,iflag_fisrtilp_qsat+1
-                
+
                 DO i=1,klon
 
-                    ! convergence = .true. until when convergence is not satisfied
-                    convergence(i)=ABS(DT(i)).GT.DDT0
-                   
-                    IF ((convergence(i) .OR. (n_i(i) .EQ. 0)) .AND. lognormale(i)) THEN
-                          
+                    ! keepgoing = .true. while convergence is not satisfied
+                    keepgoing(i)=ABS(DT(i)).GT.DDT0
+
+                    IF ((keepgoing(i) .OR. (n_i(i) .EQ. 0)) .AND. lognormale(i)) THEN
+
                         ! if not convergence:
 
@@ -776,26 +706,24 @@
                         !---------------------------------------------------------------
 
-                        ! new temperature:
+                        ! new temperature that only serves in the iteration process:
                         Tbef(i)=Tbef(i)+DT(i)
 
                         ! Rneb, qzn and zcond for lognormal PDFs
                         qtot(i)=zq(i)+zmqc(i)
-                    
+
                       ENDIF
 
                   ENDDO
 
-                  ! Calculation of saturation specific humidity and ce fraction
-                  CALL CALC_QSAT_ECMWF(klon,Tbef(:),qtot(:),pplay(:,k),RTT,0,.false.,zqs(:),zdqs(:))
-                  CALL CALC_GAMMASAT(klon,Tbef(:),qtot(:),pplay(:,k),gammasat(:),dgammasatdt(:))
+                  ! Calculation of saturation specific humidity and ice fraction
+                  CALL calc_qsat_ecmwf(klon,Tbef(:),qtot(:),pplay(:,k),RTT,0,.false.,zqs(:),zdqs(:))
+                  CALL calc_gammasat(klon,Tbef(:),qtot(:),pplay(:,k),gammasat(:),dgammasatdt(:))
                   ! saturation may occur at a humidity different from qsat (gamma qsat), so gamma correction for dqs
                   zdqs(:) = gammasat(:)*zdqs(:)+zqs(:)*dgammasatdt(:)
-                  CALL ICEFRAC_LSCP(klon, zt(:),pplay(:,k)/paprs(:,1),zfice(:),dzfice(:))
-
-
-
-                  DO i=1,klon
-
-                      IF ((convergence(i) .OR. (n_i(i) .EQ. 0)) .AND. lognormale(i)) THEN
+                  CALL icefrac_lscp(klon, zt(:),pplay(:,k)/paprs(:,1),zfice(:),dzfice(:))
+
+                  DO i=1,klon !todoan : check if loop in i is needed
+
+                      IF ((keepgoing(i) .OR. (n_i(i) .EQ. 0)) .AND. lognormale(i)) THEN
 
                         zpdf_sig(i)=ratqs(i,k)*zq(i)
@@ -810,6 +738,5 @@
                         zpdf_e2(i)=sign(min(ABS(zpdf_e2(i)),5.),zpdf_e2(i))
                         zpdf_e2(i)=1.-erf(zpdf_e2(i))
-             
-                        !--ice sursaturation by Audran
+
                         IF ((.NOT.ok_ice_sursat).OR.(Tbef(i).GT.t_glace_min)) THEN
 
@@ -826,7 +753,7 @@
                           fcontrP(i,k)=0.0  !--idem
                           qss(i,k)=0.0      !--idem
-                       
-                        ELSE
-               
+
+                       ELSE ! in case of ice supersaturation by Audran
+
                         !------------------------------------
                         ! ICE SUPERSATURATION
@@ -834,6 +761,6 @@
 
                         CALL ice_sursat(pplay(i,k), paprs(i,k)-paprs(i,k+1), dtime, i, k, t(i,k), zq(i), &
-                             gamma_ss(i,k), zqs(i), Tbef(i), rneb_seri(i,k), ratqs(i,k),               &  
-                             rneb(i,k), zqn(i), rnebss(i,k), qss(i,k),                                 & 
+                             gamma_ss(i,k), zqs(i), Tbef(i), rneb_seri(i,k), ratqs(i,k),                 &
+                             rneb(i,k), zqn(i), rnebss(i,k), qss(i,k),                                   & 
                              Tcontr(i,k), qcontr(i,k), qcontr2(i,k), fcontrN(i,k), fcontrP(i,k) )
 
@@ -862,18 +789,18 @@
                         qlbef(i)=max(0.,zqn(i)-zqs(i))
                         num = -Tbef(i)+zt(i)+rneb(i,k)*((1-zfice(i))*RLVTT &
-                        &   +zfice(i)*RLSTT)/RCPD/(1.0+RVTMP2*(zq(i)+zmqc(i)))*qlbef(i)
+                              +zfice(i)*RLSTT)/RCPD/(1.0+RVTMP2*(zq(i)+zmqc(i)))*qlbef(i)
                         denom = 1.+rneb(i,k)*((1-zfice(i))*RLVTT+zfice(i)*RLSTT)/cste*zdqs(i) &
                               -(RLSTT-RLVTT)/RCPD/(1.0+RVTMP2*(zq(i)+zmqc(i)))*rneb(i,k)      &
-                        &     *qlbef(i)*dzfice(i)
+                              *qlbef(i)*dzfice(i)
+                        ! here we update a provisory temperature variable that only serves in the iteration
+                        ! process
                         DT(i)=num/denom
                         n_i(i)=n_i(i)+1
 
-                    ENDIF ! end convergence
+                    ENDIF ! end keepgoing
 
                 ENDDO     ! end loop on i
 
         ENDDO         ! iter=1,iflag_fisrtilp_qsat+1
-
-
 
         ! P2.3> Final quantities calculation 
@@ -886,10 +813,8 @@
         ! ----------------------------------------------------------------
 
-
-
         ! Water vapor update, Phase determination and subsequent latent heat exchange
 
         ! Partition function in stratiform clouds (will be overwritten in boundary-layer MPCs)
-        CALL ICEFRAC_LSCP(klon,zt(:),pplay(:,k)/paprs(:,1),zfice(:), dzfice(:))
+        CALL icefrac_lscp(klon,zt(:),pplay(:,k)/paprs(:,1),zfice(:), dzfice(:))
 
         DO i=1, klon
@@ -923,9 +848,11 @@
                 ENDIF
 
-
                 ! water vapor update 
-                zq(i) = zq(i) - zcond(i)        
-            
+                zq(i) = zq(i) - zcond(i)
+
             ENDIF
+
+            ! c_iso : routine that computes in-cloud supersaturation
+            ! c_iso condensation of isotopes (zcond, zsursat, zfice, zq in input) 
 
             ! temperature update due to phase change
@@ -935,5 +862,4 @@
         ENDDO
 
-
         ! If vertical heterogeneity, change volume fraction 
         IF (iflag_cloudth_vert .GE. 3) THEN
@@ -945,5 +871,5 @@
     ! P3> Precipitation formation 
     ! ----------------------------------------------------------------
-    
+
     ! LTP:
     IF (iflag_evap_prec==4) THEN
@@ -955,6 +881,6 @@
         
         DO i=1, klon
-                tot_znebn(i) = 1 - (1-tot_zneb(i))*(1 - max(rneb(i,k),zneb(i))) &
-                        /(1-min(zneb(i),1-smallestreal))
+                tot_znebn(i) = 1. - (1.-tot_zneb(i))*(1 - max(rneb(i,k),zneb(i))) &
+                        /(1.-min(zneb(i),1.-smallestreal))
                 d_tot_zneb(i) = tot_znebn(i) - tot_zneb(i)
                 tot_zneb(i) = tot_znebn(i)
@@ -963,5 +889,5 @@
                 !1) Cloudy to clear air
                 d_znebprecip_cld_clr(i) = znebprecipcld(i) - min(rneb(i,k),znebprecipcld(i)) 
-                IF (znebprecipcld(i) .GT. 0) THEN
+                IF (znebprecipcld(i) .GT. 0.) THEN
                         d_zrfl_cld_clr(i) = d_znebprecip_cld_clr(i)/znebprecipcld(i)*zrflcld(i) 
                         d_zifl_cld_clr(i) = d_znebprecip_cld_clr(i)/znebprecipcld(i)*ziflcld(i) 
@@ -972,6 +898,5 @@
 
                 !2) Clear to cloudy air
-                d_znebprecip_clr_cld(i) = max(0., min(znebprecipclr(i), rneb(i,k) &
-                        - d_tot_zneb(i) - zneb(i)))
+                d_znebprecip_clr_cld(i) = max(0., min(znebprecipclr(i), rneb(i,k) - d_tot_zneb(i) - zneb(i)))
                 IF (znebprecipclr(i) .GT. 0) THEN
                         d_zrfl_clr_cld(i) = d_znebprecip_clr_cld(i)/znebprecipclr(i)*zrflclr(i) 
@@ -983,5 +908,5 @@
 
                 !Update variables
-                znebprecipcld(i) = znebprecipcld(i) + d_znebprecip_clr_cld(i) - d_znebprecip_cld_clr(i)  
+                znebprecipcld(i) = znebprecipcld(i) + d_znebprecip_clr_cld(i) - d_znebprecip_cld_clr(i)
                 znebprecipclr(i) = znebprecipclr(i) + d_znebprecip_cld_clr(i) - d_znebprecip_clr_cld(i) 
                 zrflcld(i) = zrflcld(i) + d_zrfl_clr_cld(i) - d_zrfl_cld_clr(i) 
@@ -990,8 +915,9 @@
                 ziflclr(i) = ziflclr(i) + d_zifl_cld_clr(i) - d_zifl_clr_cld(i)
 
+                ! c_iso  do the same thing for isotopes precip
         ENDDO
     ENDIF
 
-    ! Initialisation of zoliq and radliq variables
+    ! Initialisation of zoliq and radocond variables
 
     DO i = 1, klon
@@ -999,15 +925,15 @@
             zoliqi(i)= zoliq(i)*zfice(i)
             zoliql(i)= zoliq(i)*(1.-zfice(i))
+            ! c_iso : initialisation of zoliq* also for isotopes
             zrho(i,k)  = pplay(i,k) / zt(i) / RD
             zdz(i)   = (paprs(i,k)-paprs(i,k+1)) / (zrho(i,k)*RG)
             iwc(i)   = 0. 
             zneb(i)  = MAX(rneb(i,k),seuil_neb)
-            radliq(i,k) = zoliq(i)/REAL(ninter+1)
+            radocond(i,k) = zoliq(i)/REAL(ninter+1)
             radicefrac(i,k) = zfice(i)
-            radliqi(i,k)=zoliq(i)*zfice(i)/REAL(ninter+1)
-            radliql(i,k)=zoliq(i)*(1.-zfice(i))/REAL(ninter+1)
+            radocondi(i,k)=zoliq(i)*zfice(i)/REAL(ninter+1)
+            radocondl(i,k)=zoliq(i)*(1.-zfice(i))/REAL(ninter+1)
     ENDDO
 
-    ! -------------------------------------------------------------------------------
     ! Autoconversion
     ! -------------------------------------------------------------------------------
@@ -1021,5 +947,5 @@
         ENDDO
 
-        CALL FALLICE_VELOCITY(klon,iwc(:),zt(:),zrho(:,k),pplay(:,k),ptconv(:,k),velo(:,k))
+        CALL fallice_velocity(klon,iwc(:),zt(:),zrho(:,k),pplay(:,k),ptconv(:,k),velo(:,k))
 
         DO i = 1, klon
@@ -1031,4 +957,5 @@
                 zsnow=0.
                 zprecip=0.
+                ! c_iso same init for isotopes. Externalisation?
 
                 IF (zneb(i).EQ.seuil_neb) THEN
@@ -1037,4 +964,35 @@
                     zrain= 0.0
                 ELSE
+
+                    IF (ok_debug_autoconversion) THEN ! if condition to be removed after test phase
+
+                    ! water quantity to remove: zchau (Sundqvist, 1978)
+                    ! same thing for the ice: zfroi (Zender & Kiehl, 1997)
+                    IF (ptconv(i,k)) THEN ! if convective point
+                        zcl=cld_lc_con
+                        zct=1./cld_tau_con
+                        zfroi = dtime/REAL(ninter)/zdz(i)*zoliqi(i)*velo(i,k)
+                    ELSE
+                        zcl=cld_lc_lsc
+                        zct=1./cld_tau_lsc
+                        zfroi = dtime/REAL(ninter)/zdz(i)*zoliqi(i) &   ! dqice/dt=1/rho*d(rho*wice*qice)/dz
+                            *velo(i,k)
+                    ENDIF
+
+                    ! if vertical heterogeneity is taken into account, we use
+                    ! the "true" volume fraction instead of a modified 
+                    ! surface fraction (which is larger and artificially
+                    ! reduces the in-cloud water).
+
+                    IF ((iflag_cloudth_vert.GE.3).AND.(iflag_rain_incloud_vol.EQ.1)) THEN
+                        zchau = zct   *dtime/REAL(ninter) * zoliql(i) &
+                        *(1.0-EXP(-(zoliql(i)/ctot_vol(i,k)/zcl)**2))
+                    ELSE
+                        zchau = zct   *dtime/REAL(ninter) * zoliql(i) &
+                        *(1.0-EXP(-(zoliql(i)/zneb(i)/zcl)**2))        ! dqliq/dt=-qliq/tau*(1-exp(-qcin/clw)**2)
+                    ENDIF
+
+                    ELSE ! with old bug in autoconversion 
+
                     ! water quantity to remove: zchau (Sundqvist, 1978)
                     ! same thing for the ice: zfroi (Zender & Kiehl, 1997)
@@ -1055,4 +1013,5 @@
                     ! reduces the in-cloud water).
 
+
                     IF ((iflag_cloudth_vert.GE.3).AND.(iflag_rain_incloud_vol.EQ.1)) THEN
                         zchau = zct   *dtime/REAL(ninter) * zoliq(i) &
@@ -1063,18 +1022,22 @@
                     ENDIF
 
-                    zrain   = MIN(MAX(zchau,0.0),zoliq(i)*(1.-zfice(i)))
-                    zsnow   = MIN(MAX(zfroi,0.0),zoliq(i)*zfice(i)) 
+                    ENDIF ! ok_debug_autoconversion
+
+                    zrain   = MIN(MAX(zchau,0.0),zoliql(i))
+                    zsnow   = MIN(MAX(zfroi,0.0),zoliqi(i)) 
                     zprecip = MAX(zrain + zsnow,0.0)
 
                 ENDIF
-            
+
                 zoliql(i) = MAX(zoliq(i)*(1.-zfice(i))-1.*zrain  , 0.0)
                 zoliqi(i) = MAX(zoliq(i)*zfice(i)-1.*zsnow  , 0.0)
                 zoliq(i)  = MAX(zoliq(i)-zprecip , 0.0)
 
-                radliq(i,k) = radliq(i,k) + zoliq(i)/REAL(ninter+1)
-                radliql(i,k) = radliql(i,k) + zoliql(i)/REAL(ninter+1)
-                radliqi(i,k) = radliqi(i,k) + zoliqi(i)/REAL(ninter+1)
-           
+                ! c_iso: call isotope_conversion (for readibility) or duplicate 
+
+                radocond(i,k) = radocond(i,k) + zoliq(i)/REAL(ninter+1)
+                radocondl(i,k) = radocondl(i,k) + zoliql(i)/REAL(ninter+1)
+                radocondi(i,k) = radocondi(i,k) + zoliqi(i)/REAL(ninter+1)
+
             ENDIF ! rneb >0
 
@@ -1083,15 +1046,15 @@
     ENDDO      ! n = 1,niter
 
-    
-
     ! Precipitation flux calculation
 
     DO i = 1, klon
-
-
-            ziflprev(i)=zifl(i)
+            
+            IF (iflag_evap_prec.EQ.4) THEN
+                ziflprev(i)=ziflcld(i)
+            ELSE
+                ziflprev(i)=zifl(i)*zneb(i)
+            ENDIF
 
             IF (rneb(i,k) .GT. 0.0) THEN
-                
 
                ! CR&JYG: We account for the Wegener-Findeisen-Bergeron process in the precipitation flux:
@@ -1126,51 +1089,50 @@
                     ! iced water budget
                     zqpreci(i) = max (zqpreci(i) - Deltaqprecl - Deltaq, 0.)
-           
-                IF (iflag_evap_prec.EQ.4) THEN                                                            
-                    zrflcld(i) = zrflcld(i)+zqprecl(i) &                                                   
-                    *(paprs(i,k)-paprs(i,k+1))/(RG*dtime)                                                
-                    ziflcld(i) = ziflcld(i)+ zqpreci(i) &                                                  
-                        *(paprs(i,k)-paprs(i,k+1))/(RG*dtime)                                            
-                    znebprecipcld(i) = rneb(i,k)                                                          
-                    zrfl(i) = zrflcld(i) + zrflclr(i)                                                      
-                    zifl(i) = ziflcld(i) + ziflclr(i)                                                    
-                ELSE                                 
+
+                    ! c_iso : mv here condensation of isotopes + redispatchage en precip 
+
+                IF (iflag_evap_prec.EQ.4) THEN
+                    zrflcld(i) = zrflcld(i)+zqprecl(i) &
+                    *(paprs(i,k)-paprs(i,k+1))/(RG*dtime)
+                    ziflcld(i) = ziflcld(i)+ zqpreci(i) &
+                        *(paprs(i,k)-paprs(i,k+1))/(RG*dtime)
+                    znebprecipcld(i) = rneb(i,k)
+                    zrfl(i) = zrflcld(i) + zrflclr(i)
+                    zifl(i) = ziflcld(i) + ziflclr(i)
+                ELSE
                     zrfl(i) = zrfl(i)+ zqprecl(i)        &
                     *(paprs(i,k)-paprs(i,k+1))/(RG*dtime) 
                     zifl(i) = zifl(i)+ zqpreci(i)        &
-                   *(paprs(i,k)-paprs(i,k+1))/(RG*dtime)  
-                ENDIF
+                   *(paprs(i,k)-paprs(i,k+1))/(RG*dtime)
+                ENDIF
+                ! c_iso : same for isotopes
  
            ENDIF ! rneb>0
 
-
    ENDDO
 
-
-
-
-    ! LTP: limit of surface cloud fraction covered by precipitation when the local intensity of the flux is below rain_int_min                                                                              
+    ! LTP: limit of surface cloud fraction covered by precipitation when the local intensity of the flux is below rain_int_min
     ! if iflag_evap_pre=4
-    IF (iflag_evap_prec.EQ.4) THEN  
-
-        DO i=1,klon                                        
-                
-            IF ((zrflclr(i) + ziflclr(i)) .GT. 0. ) THEN     
+    IF (iflag_evap_prec.EQ.4) THEN
+
+        DO i=1,klon
+
+            IF ((zrflclr(i) + ziflclr(i)) .GT. 0. ) THEN
                 znebprecipclr(i) = min(znebprecipclr(i),max(zrflclr(i)/ &
                 (MAX(znebprecipclr(i),seuil_neb)*rain_int_min), ziflclr(i)/(MAX(znebprecipclr(i),seuil_neb)*rain_int_min)))
             ELSE
-                znebprecipclr(i)=0.                                                                   
-            ENDIF  
-                                                                                                         
-            IF ((zrflcld(i) + ziflcld(i)) .GT. 0.) THEN                                                  
+                znebprecipclr(i)=0.0
+            ENDIF
+
+            IF ((zrflcld(i) + ziflcld(i)) .GT. 0.) THEN
                 znebprecipcld(i) = min(znebprecipcld(i), max(zrflcld(i)/ &
                 (MAX(znebprecipcld(i),seuil_neb)*rain_int_min), ziflcld(i)/(MAX(znebprecipcld(i),seuil_neb)*rain_int_min)))
-            ELSE                                                                                     
-                znebprecipcld(i)=0.                                                                    
-            ENDIF     
-
-        ENDDO       
-
-    ENDIF  
+            ELSE
+                znebprecipcld(i)=0.0
+            ENDIF
+
+        ENDDO
+
+    ENDIF
 
     ! End of precipitation formation
@@ -1186,16 +1148,16 @@
         d_qi(i,k) = zfice(i)*zoliq(i)
         d_q(i,k) = zq(i) - q(i,k)
+        ! c_iso: same for isotopes
         d_t(i,k) = zt(i) - t(i,k)
     ENDDO
 
     ! Calculation of the concentration of condensates seen by the radiation scheme
-    ! for liquid phase, we take radliql
-    ! for ice phase, we take radliqi if we neglect snowfall, otherwise (ok_radliq_snow=true) 
-    ! we recaulate radliqi to account for contributions from the precipitation flux
-
-
-    IF ((ok_radliq_snow) .AND. (k .LT. klev)) THEN
+    ! for liquid phase, we take radocondl
+    ! for ice phase, we take radocondi if we neglect snowfall, otherwise (ok_radocond_snow=true) 
+    ! we recaulate radocondi to account for contributions from the precipitation flux
+
+    IF ((ok_radocond_snow) .AND. (k .LT. klev)) THEN
         ! for the solid phase (crystals + snowflakes)
-        ! we recalculate radliqi by summing
+        ! we recalculate radocondi by summing
         ! the ice content calculated in the mesh
         ! + the contribution of the non-evaporated snowfall 
@@ -1203,25 +1165,22 @@
         DO i=1,klon
            IF (ziflprev(i) .NE. 0.0) THEN
-              radliqi(i,k)=zoliq(i)*zfice(i)+zqpreci(i)+ziflprev(i)/zrho(i,k+1)/velo(i,k+1)
+              radocondi(i,k)=zoliq(i)*zfice(i)+zqpreci(i)+ziflprev(i)/zrho(i,k+1)/velo(i,k+1)
            ELSE
-              radliqi(i,k)=zoliq(i)*zfice(i)+zqpreci(i)  
+              radocondi(i,k)=zoliq(i)*zfice(i)+zqpreci(i)
            ENDIF
-           radliq(i,k)=radliql(i,k)+radliqi(i,k)
+           radocond(i,k)=radocondl(i,k)+radocondi(i,k)
         ENDDO
     ENDIF
 
-    ! caculate the percentage of ice in "radliq" so cloud+precip seen by the radiation scheme
+    ! caculate the percentage of ice in "radocond" so cloud+precip seen by the radiation scheme
     DO i=1,klon
-        IF (radliq(i,k) .GT. 0.) THEN
-            radicefrac(i,k)=MIN(MAX(radliqi(i,k)/radliq(i,k),0.),1.)
+        IF (radocond(i,k) .GT. 0.) THEN
+            radicefrac(i,k)=MIN(MAX(radocondi(i,k)/radocond(i,k),0.),1.)
         ENDIF
     ENDDO
-
-
 
     ! ----------------------------------------------------------------
     ! P4> Wet scavenging
     ! ----------------------------------------------------------------
-
 
     !Scavenging through nucleation in the layer
@@ -1246,16 +1205,13 @@
 
             zfrac_lessi = 1. - EXP(zalpha_tr*zprec_cond(i)/zneb(i))
-            pfrac_nucl(i,k)=pfrac_nucl(i,k)*(1.-zneb(i)*zfrac_lessi)
             frac_nucl(i,k)= 1.-zneb(i)*zfrac_lessi 
-    
+
             ! Nucleation with a factor of -1 instead of -0.5
             zfrac_lessi = 1. - EXP(-zprec_cond(i)/zneb(i))
-            pfrac_1nucl(i,k)=pfrac_1nucl(i,k)*(1.-zneb(i)*zfrac_lessi)
 
         ENDIF
-        
-    ENDDO      
-
-     
+
+    ENDDO
+
     ! Scavenging through impaction in the underlying layer
 
@@ -1273,5 +1229,4 @@
 
               zfrac_lessi = 1. - EXP(zalpha_tr*zprec_cond(i)/zneb(i))
-              pfrac_impa(i,kk)=pfrac_impa(i,kk)*(1.-zneb(i)*zfrac_lessi)
               frac_impa(i,kk)= 1.-zneb(i)*zfrac_lessi
 
@@ -1281,5 +1236,5 @@
 
     ENDDO
-     
+
     !--save some variables for ice supersaturation
     !
@@ -1294,10 +1249,10 @@
         qclr(i,k) = MAX(1.e-10,zq(i) - qvc(i,k) - qss(i,k))  !--added by OB because of pathologic cases with the lognormal
         qcld(i,k) = qvc(i,k) + zcond(i)
-   END DO
+   ENDDO
    !q_sat
-   CALL CALC_QSAT_ECMWF(klon,Tbef(:),qzero(:),pplay(:,k),RTT,1,.false.,zqsatl(:,k),zdqs(:))
-   CALL CALC_QSAT_ECMWF(klon,Tbef(:),qzero(:),pplay(:,k),RTT,2,.false.,zqsats(:,k),zdqs(:))     
-
-END DO
+   CALL calc_qsat_ecmwf(klon,Tbef(:),qzero(:),pplay(:,k),RTT,1,.false.,qsatl(:,k),zdqs(:))
+   CALL calc_qsat_ecmwf(klon,Tbef(:),qzero(:),pplay(:,k),RTT,2,.false.,qsats(:,k),zdqs(:))
+
+ENDDO
 
 !======================================================================
@@ -1309,4 +1264,5 @@
       snow(i) = zifl(i)
       rain(i) = zrfl(i)
+      ! c_iso final output
   ENDDO
 
@@ -1315,6 +1271,6 @@
   ENDIF
 
-END SUBROUTINE LSCP
+END SUBROUTINE lscp
 !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 
-END MODULE LSCP_MOD
+END MODULE lscp_mod
Index: LMDZ6/branches/Portage_acc/libf/phylmd/mo_simple_plumes.F90
===================================================================
--- LMDZ6/branches/Portage_acc/libf/phylmd/mo_simple_plumes.F90	(revision 4445)
+++ LMDZ6/branches/Portage_acc/libf/phylmd/mo_simple_plumes.F90	(revision 4446)
@@ -38,5 +38,5 @@
 !$OMP THREADPRIVATE(sp_initialized)
 
-  REAL ::                                      &
+  REAL, SAVE ::                                &
        plume_lat      (nplumes)               ,& !< latitude of plume center (AOD maximum)
        plume_lon      (nplumes)               ,& !< longitude of plume center (AOD maximum)
@@ -54,6 +54,4 @@
        theta          (nfeatures,nplumes)     ,& !< Rotation angle of plume feature
        ftr_weight     (nfeatures,nplumes)     ,& !< Feature weights 
-       time_weight    (nfeatures,nplumes)     ,& !< Time weights 
-       time_weight_bg (nfeatures,nplumes)     ,& !< as time_weight but for natural background in Twomey effect 
        year_weight    (nyears,nplumes)        ,& !< Yearly weight for plume
        ann_cycle      (nfeatures,ntimes,nplumes) !< annual cycle for plume feature
@@ -61,4 +59,8 @@
 !$OMP THREADPRIVATE(sig_lon_E,sig_lon_W,sig_lat_E,sig_lat_W,theta,ftr_weight,year_weight,ann_cycle)
 
+  REAL ::                                      &
+       time_weight    (nfeatures,nplumes)     ,& !< Time weights 
+       time_weight_bg (nfeatures,nplumes)        !< as time_weight but for natural background in Twomey effect 
+
   PUBLIC sp_aop_profile
 
@@ -80,5 +82,4 @@
     CHARACTER (len = 50)     :: modname = 'mo_simple_plumes.sp_setup'
     CHARACTER (len = 80)     :: abort_message
-
     !
     ! ---------- 
@@ -130,4 +131,5 @@
           CALL abort_physic(modname,abort_message,1)
        ENDIF
+       !
        iret = nf90_inq_varid(ncid, "plume_lon", VarId)
        iret = nf90_get_var(ncid, VarID, plume_lon(:), start=(/1/),count=(/nplumes/))
@@ -136,4 +138,5 @@
           CALL abort_physic(modname,abort_message,1)
        ENDIF
+       !
        iret = nf90_inq_varid(ncid, "beta_a"   , VarId)
        iret = nf90_get_var(ncid, VarID, beta_a(:)   , start=(/1/),count=(/nplumes/))
@@ -142,4 +145,5 @@
           CALL abort_physic(modname,abort_message,1)
        ENDIF
+       !
        iret = nf90_inq_varid(ncid, "beta_b"   , VarId)
        iret = nf90_get_var(ncid, VarID, beta_b(:)   , start=(/1/),count=(/nplumes/))
@@ -148,4 +152,5 @@
           CALL abort_physic(modname,abort_message,1)
        ENDIF
+       !
        iret = nf90_inq_varid(ncid, "aod_spmx" , VarId)
        iret = nf90_get_var(ncid, VarID, aod_spmx(:)  , start=(/1/),count=(/nplumes/))
@@ -154,4 +159,5 @@
           CALL abort_physic(modname,abort_message,1)
        ENDIF
+       !
        iret = nf90_inq_varid(ncid, "aod_fmbg" , VarId)
        iret = nf90_get_var(ncid, VarID, aod_fmbg(:)  , start=(/1/),count=(/nplumes/))
@@ -160,4 +166,5 @@
           CALL abort_physic(modname,abort_message,1)
        ENDIF
+       !
        iret = nf90_inq_varid(ncid, "ssa550"   , VarId)
        iret = nf90_get_var(ncid, VarID, ssa550(:)  , start=(/1/),count=(/nplumes/))
@@ -166,4 +173,5 @@
           CALL abort_physic(modname,abort_message,1)
        ENDIF
+       !
        iret = nf90_inq_varid(ncid, "asy550"   , VarId)
        iret = nf90_get_var(ncid, VarID, asy550(:)  , start=(/1/),count=(/nplumes/))
@@ -172,4 +180,5 @@
           CALL abort_physic(modname,abort_message,1)
        ENDIF
+       !
        iret = nf90_inq_varid(ncid, "angstrom" , VarId)
        iret = nf90_get_var(ncid, VarID, angstrom(:), start=(/1/),count=(/nplumes/))
@@ -185,4 +194,5 @@
           CALL abort_physic(modname,abort_message,1)
        ENDIF
+       !
        iret = nf90_inq_varid(ncid, "sig_lat_E"     , VarId)
        iret = nf90_get_var(ncid, VarID, sig_lat_E(:,:)    , start=(/1,1/),count=(/nfeatures,nplumes/))
@@ -191,4 +201,5 @@
           CALL abort_physic(modname,abort_message,1)
        ENDIF
+       !
        iret = nf90_inq_varid(ncid, "sig_lon_E"     , VarId)
        iret = nf90_get_var(ncid, VarID, sig_lon_E(:,:)    , start=(/1,1/),count=(/nfeatures,nplumes/))
@@ -197,4 +208,5 @@
           CALL abort_physic(modname,abort_message,1)
        ENDIF
+       !
        iret = nf90_inq_varid(ncid, "sig_lon_W"     , VarId)
        iret = nf90_get_var(ncid, VarID, sig_lon_W(:,:)    , start=(/1,1/),count=(/nfeatures,nplumes/))
@@ -203,4 +215,5 @@
           CALL abort_physic(modname,abort_message,1)
        ENDIF
+       !
        iret = nf90_inq_varid(ncid, "theta"         , VarId)
        iret = nf90_get_var(ncid, VarID, theta(:,:)        , start=(/1,1/),count=(/nfeatures,nplumes/))
@@ -209,4 +222,5 @@
           CALL abort_physic(modname,abort_message,1)
        ENDIF
+       !
        iret = nf90_inq_varid(ncid, "ftr_weight"    , VarId)
        iret = nf90_get_var(ncid, VarID, ftr_weight(:,:)   , start=(/1,1/),count=(/nfeatures,nplumes/))
@@ -215,4 +229,5 @@
           CALL abort_physic(modname,abort_message,1)
        ENDIF
+       !
        iret = nf90_inq_varid(ncid, "year_weight"   , VarId)
        iret = nf90_get_var(ncid, VarID, year_weight(:,:)  , start=(/1,1/),count=(/nyears,nplumes   /))
@@ -221,4 +236,5 @@
           CALL abort_physic(modname,abort_message,1)
        ENDIF
+       !
        iret = nf90_inq_varid(ncid, "ann_cycle"     , VarId)
        iret = nf90_get_var(ncid, VarID, ann_cycle(:,:,:)  , start=(/1,1,1/),count=(/nfeatures,ntimes,nplumes/))
@@ -288,5 +304,5 @@
       time_weight_bg(1,iplume) = ann_cycle(1,iweek,iplume)
       time_weight_bg(2,iplume) = ann_cycle(2,iweek,iplume) 
-    END DO
+    ENDDO
     
     RETURN
@@ -375,11 +391,11 @@
         z_beta(icol,k)   = MERGE(1.0, 0.0, z(icol,k) >= oro(icol))
         eta(icol,k)      = MAX(0.0,MIN(1.0,z(icol,k)/15000.))
-      END DO
-    END DO
+      ENDDO
+    ENDDO
     DO icol=1,ncol
       dNovrN(icol)   = 1.0
       caod_sp(icol)  = 0.0
       caod_bg(icol)  = 0.02
-    END DO
+    ENDDO
     !
     ! sum contribution from plumes to construct composite profiles of aerosol optical properties
@@ -391,16 +407,16 @@
       DO icol=1,ncol
         beta_sum(icol) = 0.
-      END DO
+      ENDDO
       DO k=1,nlevels
         DO icol=1,ncol
           prof(icol,k)   = (eta(icol,k)**(beta_a(iplume)-1.) * (1.-eta(icol,k))**(beta_b(iplume)-1.)) * dz(icol,k)
           beta_sum(icol) = beta_sum(icol) + prof(icol,k)
-        END DO
-      END DO
+        ENDDO
+      ENDDO
       DO k=1,nlevels
         DO icol=1,ncol
           prof(icol,k)   = ( prof(icol,k) / beta_sum(icol) ) * z_beta(icol,k)
-        END DO
-      END DO
+        ENDDO
+      ENDDO
       !
       ! calculate plume weights
@@ -443,5 +459,5 @@
         ssa(icol) = (ssa550(iplume) * lfactor**4) / ((ssa550(iplume) * lfactor**4) + ((1-ssa550(iplume)) * lfactor))
         asy(icol) =  asy550(iplume) * SQRT(lfactor)
-      END DO
+      ENDDO
       !
       ! distribute plume optical properties across its vertical profile weighting by optical depth and scaling for
@@ -458,7 +474,7 @@
           ssa_prof(icol,k) = ssa_prof(icol,k) + aod_lmd * ssa(icol)
           aod_prof(icol,k) = aod_prof(icol,k) + aod_lmd
-        END DO
-      END DO
-    END DO
+        ENDDO
+      ENDDO
+    ENDDO
     !
     ! complete optical depth weighting
@@ -468,6 +484,6 @@
         asy_prof(icol,k) = MERGE(asy_prof(icol,k)/ssa_prof(icol,k), 0.0, ssa_prof(icol,k) > TINY(1.))
         ssa_prof(icol,k) = MERGE(ssa_prof(icol,k)/aod_prof(icol,k), 1.0, aod_prof(icol,k) > TINY(1.))
-      END DO
-    END DO
+      ENDDO
+    ENDDO
     !
     ! calculate effective radius normalization (divisor) factor
@@ -475,5 +491,5 @@
     DO icol=1,ncol
       dNovrN(icol) = LOG((1000.0 * (caod_sp(icol) + caod_bg(icol))) + 1.0)/LOG((1000.0 * caod_bg(icol)) + 1.0)
-    END DO
+    ENDDO
 
     RETURN
